<template>
  <div class="auth-wrapper auth-v2">
    <b-row class="justify-content-md-center" >

      <!-- Brand logo-->
      
      <!-- /Brand logo-->

      <!-- Left Text-->
      <b-col
        lg="8"
        class=" auth-bg px-2 "
      >
        <div class="w-100 d-flex align-items-center justify-content-center px-5">
          <b-img
            fluid
            :src="imgUrl"
            alt="Login V2"
          />
        </div>
      </b-col>
      <!-- /Left Text-->

      <!-- Login-->
      <b-col
        lg="4"
        class="d-flex align-items-center  px-2 "

      >
   
         
      
        <b-col
          sm="6"
          md="6"
          lg="12"
          class="px-xl-2 mx-auto"
        >
         
          <b-card-title
            class="mb-1 font-weight-bold"
            title-tag="h2"
          >
          
           <img src="https://quantumbit.mx/assets/img/logo_quantumbit.svg" >
          </b-card-title>
       

          <!-- form -->
          <validation-observer
            ref="loginForm"
            #default="{invalid}"
          >
            <b-alert variant="warning" :show="showAlert">Error: credenciales incorrectas</b-alert>
            <b-form
              class="auth-login-form mt-2"
              @submit.prevent="login"
            >
              <!-- email -->
              <b-form-group
                label="Nombre de usuario"
                label-for="login-email"
              >
                <validation-provider
                  #default="{ errors }"
                  name="Usuario"
                >
                  <b-form-input
                    id="login-username"
                    v-model="username"
                    :state="errors.length > 0 ? false:null"
                    name="login-uername"
                    placeholder="username"
                  />
                  <small class="text-danger">{{ errors[0] }}</small>
                </validation-provider>
              </b-form-group>

              <!-- forgot password -->
              <b-form-group>
                <validation-provider
                  #default="{ errors }"
                  name="Password"
                  vid="password"
                  rules="required"
                >
                  <b-input-group
                    class="input-group-merge"
                    :class="errors.length > 0 ? 'is-invalid':null"
                  >
                    <b-form-input
                      id="login-password"
                      v-model="password"
                      :state="errors.length > 0 ? false:null"
                      class="form-control-merge"
                      :type="passwordFieldType"
                      name="login-password"
                      placeholder="Password"
                    />
                    <b-input-group-append is-text>
                      <feather-icon
                        class="cursor-pointer"
                        :icon="passwordToggleIcon"
                        @click="togglePasswordVisibility"
                      />
                    </b-input-group-append>
                  </b-input-group>
                  <small class="text-danger">{{ errors[0] }}</small>
                </validation-provider>
              </b-form-group>

             

              <!-- submit buttons -->
              <b-button
                type="submit"
                variant="primary"
                block
                :disabled="invalid"
              >
                Iniciar sesión
              </b-button>
            </b-form>
          </validation-observer>

          


        </b-col>
      </b-col>
    <!-- /Login-->
    </b-row>
  </div>
</template>

<script>
/* eslint-disable global-require */
import { ValidationProvider, ValidationObserver } from 'vee-validate'
import VuexyLogo from '@core/layouts/components/Logo.vue'
import {
  BRow, BCol, BLink, BFormGroup, BFormInput, BInputGroupAppend, BInputGroup, BFormCheckbox, BCardText, BCardTitle, BImg, BForm, BButton, BAlert, VBTooltip,
} from 'bootstrap-vue'
import useJwt from '@/auth/jwt/useJwt'
import { required, email } from '@validations'
import { togglePasswordVisibility } from '@core/mixins/ui/forms'
import store from '@/store/index'
import { getHomeRouteForLoggedInUser } from '@/auth/utils'

import ToastificationContent from '@core/components/toastification/ToastificationContent.vue'

export default {
  directives: {
    'b-tooltip': VBTooltip,
  },
  components: {
    BRow,
    BCol,
    BLink,
    BFormGroup,
    BFormInput,
    BInputGroupAppend,
    BInputGroup,
    BFormCheckbox,
    BCardText,
    BCardTitle,
    BImg,
    BForm,
    BButton,
    BAlert,
    VuexyLogo,
    ValidationProvider,
    ValidationObserver,
  },
  mixins: [togglePasswordVisibility],
  data() {
    return {
      status: '',
      password: '',
      username: '',
      sideImg: require('@/assets/images/pages/login.jpg'),

      // validation rules
      required,
      email,
      showAlert:false
    }
  },
  computed: {
    passwordToggleIcon() {
      return this.passwordFieldType === 'password' ? 'EyeIcon' : 'EyeOffIcon'
    },
    imgUrl() {
     
      return this.sideImg
    },
  },

  methods: {
    login() {
      this.$refs.loginForm.validate().then(success => {
        if (success) {
          this.showAlert=false
          this.$http.post('login',{
            nickname: this.username,
            password: this.password,
          })
            .then(response => {
              if (response.status == 401) {
                this.showAlert=true
                this.$toast({
                    component: ToastificationContent,
                    position: 'top-right',
                    props: {
                      title: `Credenciales incorrectas!`,
                      icon: 'CoffeeIcon',
                      variant: 'Danger',
                      text: `Intente nuevamente con los datos correctos`,
                    },
                })
              }else{
              const userData  = response.data.user
              userData.fullName = response.data.user.name
              userData.username = response.data.user.nickname
              userData.role = response.data.user.roles[0].name
              useJwt.setToken(response.data.access_token)
              useJwt.setRefreshToken(response.data.access_token)
              localStorage.setItem('userData', JSON.stringify(userData))
              localStorage.setItem('accessToken', response.data.access_token)
              
              this.$http.get('email/login',{
                params:{email:userData.email}
              }).catch(err=>{
                console.log(err)
              })
              let route = '/dashboard/user'
              if (this.hasPermission('view_admin_dashboard' )) {
                route = '/dashboard/admin'
              } else {
                route = '/dashboard/user'
              }
              this.$router.replace(route)
                .then(() => {
                  this.$toast({
                    component: ToastificationContent,
                    position: 'top-right',
                    props: {
                      title: `Bienvenid@ ${userData.name}`,
                      icon: 'CoffeeIcon',
                      variant: 'success',
                      text: `Has iniciado sesión correctamente!`,
                    },
                  })
                })
              }
            })
           
        }
      })
    },
    
  }
}
</script>

<style lang="scss">
@import '@core/scss/vue/pages/page-auth.scss';
</style>
